#!/usr/bin/perl -w
#
# Copyright (C) 2001,2002 asdfGroup.com Inc. All rights reserved.
#
# This library is a commercial product and it is subject to the license
# agreement that can be found at the following URL:
#   http://www.asdfGroup.com/license.html
# Please contact our staff if you will have any questions:
#   mailto:staff@asdfGroup.com
#

use strict;

{ my %Enc=(qw'& &amp; > &gt; < &lt; " &quot;',map{chr,"&#$_;"}(0..8,11..31,127,139,155));
sub Enc {
    my $html_unsafe =  ($#_ == -1) ? $_ : $_[0];
    $html_unsafe = '' unless defined $html_unsafe;
    $html_unsafe    =~ s/([\&\>\<\"\0-\10\13-\37\177])/$Enc{$1}/gs;
    return $html_unsafe;
}}

{ my %UnEnc=reverse(qw'& &amp; > &gt; < &lt; " &quot;',map{chr,"&#$_;"}(0..255));
sub UnEnc {
    my $html =  ($#_ == -1) ? $_ : $_[0];
    return '' unless defined $html;
    $html    =~ s/(&(?:#\d+|\w+);)/$UnEnc{$1}/gs;
    return $html;
}}

{ my %EncUri = map { chr($_), sprintf("%%%02X",$_) } 0..255;
sub EncUri {
    my $to_escape =  ($#_ == -1) ? $_ : $_[0];
    return '' unless defined($to_escape);
    my $regexp    =  $_[1] || qr/\W/; 
    $to_escape    =~ s/($regexp)/$EncUri{$1}/g;
    return $to_escape;
}}

sub UnEncUri {
    my $to_unescape =  ($#_ == -1) ? $_ : $_[0];
    $to_unescape    =~ s/%([0-9A-Fa-f]{2})/chr(hex($1))/eg;
    return $to_unescape;
}

1;
