#!/usr/bin/perl -w
# produce warning if used with non-numeric values
use Test; 
BEGIN { plan tests => 8 }
BEGIN { unshift @INC, "../blib/lib" }
use POWER::lib;

$min    = Min();
ok($min, undef,             "min, null list");
$max    = Max();
ok($max, undef,             "max, null list");

$min    = Min(5);
$max    = Max(5);
ok($min, 5,                 "min, one element");
ok($max, 5,                 "max, one element");

$min    = Min(1,2,3,4,5);
$max    = Max(1,2,3,4,5);
ok($min, 1,                 "min, 1 .. 5");
ok($max, 5,                 "max, 1 .. 5");

$min    = Min(-0.4, 0, 0.4, -1.5, 1.5, 0);
$max    = Max(-0.4, 0, 0.4, -1.5, 1.5, 0);
ok($min, -1.5,              "min, -1.5 .. 1.5");
ok($max, 1.5,               "max, -1.5 .. 1.5");

